<h2 style="margin-top: 1em;"><?php echo _T("DHCP Failover configuration"); ?></h2>

<?php

require_once("includes/FormHandler.php");

global $result;
global $error;

if ($_POST)
    $FH = new FormHandler("dhcpFailoverFH", $_POST);
else
    $FH = new FormHandler("dhcpFailoverFH", array());

function updateFailoverConfig($FH) {
    global $result;
    global $error;
    
    $type = "";
    if ($FH->getPostValue("isOneSideConfig") == "" )
	$type = $FH->getPostValue("isPrimary") == "on" ? "primary" : "secondary";
    
    setFailoverConfig($type, $FH->getPostValue("primaryIp"), $FH->getPostValue("secondaryIp"),
    		      $FH->getPostValue("primaryPort"), $FH->getPostValue("secondaryPort"), $FH->getPostValue("delay"),
                      $FH->getPostValue("update"), $FH->getPostValue("balance"), $FH->getPostValue("mclt"), 
                      $FH->getPostValue("split"));
    if(!isXMLRPCError()) {
        $result .= _T("Failover configuration updated.") . "<br />";
        $result .= _T("You must restart DHCP services.") . "<br />";
    }
    else
        $error .= _T("Failed to update the failover configuration.") . "<br />";

}

// get current configuration
$failoverConfig = getFailoverConfig();
$FH->setArr($failoverConfig);

// default values
$show = isset($failoverConfig['primaryIp']);

$isOneSideConfig = isset($failoverConfig['secondary'][0]);


if ($show) 
    $isPrimary = ($failoverConfig['type'][0] == "primary");
else
    $isPrimary = False;



if ($_POST) {
    $result = "";
    $error = "";

    if ($FH->isUpdated("dhcpFailover") and $FH->getValue("dhcpFailover") == "off") {
        delFailoverConfig();
        delSecondaryServer();
        if(!isXMLRPCError())
            $result .= _T("Failover configuration disabled.") . "<br />";
        else
            $error .= _T("Failed to disable the failover configuration.") . "<br />";
    }
    
    if ($FH->isUpdated("isOneSideConfig") and $FH->getValue("isOneSideConfig") == "off") {
	delSecondaryServer();
    }
    
    if ($FH->getPostValue("dhcpFailover") == "on") {
	$show = true;
	
        $primaryIp = $_POST["primaryIp"];
        $primaryPort = $_POST["primaryPort"];
        $isOneSideConfig = $_POST["isOneSideConfig"] == "on";
        $secondary = $isOneSideConfig ? $_POST["secondary"] : "";
        $secondaryIp = $_POST["secondaryIp"];
        $secondaryPort = $_POST["secondaryPort"];
        $delay = $_POST["delay"];
        $update = $_POST["update"];
        $balance = $_POST["balance"];

	if ($FH->getPostValue("isPrimary") == "on") {
    	    $mclt = $_POST["mclt"];
    	    $split = $_POST["split"];
	} else {
    	    $mclt = "1800";
    	    $split = "128";
	}
	
        if ($primaryIp && $primaryPort && $secondaryIp && $secondaryPort && $delay && $update && $balance && $mclt && $split && $isOneSideConfig ? $secondary : true ) {
    	    if ($_POST["isOneSideConfig"] == "on" && $FH->isUpdated("secondary")) {
        	updateSecondaryServer($FH->getValue("secondary"));
        	if(!isXMLRPCError()) {
            	    $result .= sprintf(_T("%s is set as the standby DHCP server."), $FH->getValue("secondary")) . "<br />";
            	    updateFailoverConfig($FH);
        	} else $error .= sprintf(_T("Failed to set %s as the standby DHCP server."), $FH->getValue("secondary")) . "<br />";
    	    } else 
    		if ($FH->isUpdated("isPrimary") or $FH->isUpdated("secondaryIp") or $FH->isUpdated("primaryIp") or $FH->isUpdated("primaryPort") or 
    		    $FH->isUpdated("secondaryPort") or $FH->isUpdated("delay") or $FH->isUpdated("update") or $FH->isUpdated("balance") or 
    		    $FH->isUpdated("mclt") or $FH->isUpdated("split") or $FH->isUpdated("isOneSideConfig")) 
        	    updateFailoverConfig($FH);
    		
	}  else {
	
            $error .= " " . _T("DHCP failover configuration must be filled in if you want to enable it");

            if (!$primaryIp) setFormError("primaryIp");
            if (!$primaryPort) setFormError("primaryPort");
            if (!$secondary && $isOneSideConfig) setFormError("secondary"); 
            if (!$secondaryIp) setFormError("secondaryIp");
            if (!$secondaryPort) setFormError("secondaryPort");
            if (!$delay) setFormError("delay");
            if (!$update) setFormError("update");
            if (!$balance) setFormError("balance");
            if (!$mclt) setFormError("mclt");
            if (!$split) setFormError("split");
        }

    }

    // prepare the result popup
    $resultPopup = new NotifyWidget();
    // add error messages
    if ($error) {
        $resultPopup->add('<div class="errorCode">' . $error . '</div>');
        $resultPopup->setLevel(5);
    }
    // add info messages
    if ($result)
        $resultPopup->add('<div class="validCode">' . $result . '</div>');

    if(!$error)
        header("Location: " . urlStrRedirect("network/network/services"));
}




$f = new ValidatingForm();

$f->push(new Table());
$f->add(
    new TrFormElement(_T("Enable DHCP failover"), new CheckboxTpl("dhcpFailover")),
        array("value"=> $show ? "checked": "", "extraArg" => 'onclick="toggleVisibility(\'dhcpfailoverdiv\');"')
);
$f->pop();

$dhcpfailoverdiv = new Div(array("id" => "dhcpfailoverdiv"));
$dhcpfailoverdiv->setVisibility($show);

$f->push($dhcpfailoverdiv);
$f->push(new Table());

$f->add(
    new TrFormElement(_T("Failover configuration is stored on this server only"), new CheckboxTpl("isOneSideConfig")),
    array("value"=> $isOneSideConfig ? "checked": "", 
          "extraArg" => 'onclick="toggleVisibility(\'dhcponesideconfigdiv\');toggleVisibility(\'dhcptwosideconfigdiv\'); var show = document.getElementById(\'isPrimary\').checked || this.checked; changeObjectDisplay(\'dhcpprimaryfailoveroptionsdiv\', show ? \'inline\' : \'none\');"'
    )
);

$f->pop();


$dhcpTwoSideConfigDiv = new Div(array("id" => "dhcptwosideconfigdiv"));
$dhcpTwoSideConfigDiv->setVisibility(!$isOneSideConfig);
$f->push($dhcpTwoSideConfigDiv);

$f->push(new Table());

$f->add(
    new TrFormElement(_T("Primary DHCP server"), new CheckboxTpl("isPrimary")),
    array("value"=> $isPrimary ? "checked": "", "extraArg" => 'onclick="toggleVisibility(\'dhcpprimaryfailoveroptionsdiv\');"')
);

$f->pop();
$f->pop();



$f->push(new Table());

$f->add(
    new TrFormElement(_T("DHCP server name"), new HiddenTpl("primary")),
    array("value" => $FH->getArrayOrPostValue("primary"))
);

$f->add(
    new TrFormElement(_T("DHCP IP address"), new IPInputTpl("primaryIp")),
    array("value" => $FH->getArrayOrPostValue("primaryIp"))
);
$f->pop();

$f->push(new DivExpertMode());
$f->push(new Table());
$f->add(
    new TrFormElement(_T("DHCP failover port"), new InputTpl("primaryPort"),
    array("tooltip" => _T("TCP port where the server listen to failover messages", "network"))),
    array("value" => $FH->getArrayOrPostValue("primaryPort"))
);
$f->pop();
$f->pop();

$dhcpOneSideConfigDiv = new Div(array("id" => "dhcponesideconfigdiv"));
$dhcpOneSideConfigDiv->setVisibility($isOneSideConfig);
$f->push($dhcpOneSideConfigDiv);

$f->push(new Table());

$f->add(
    new TrFormElement(_T("Standby DHCP server name"), new InputTpl("secondary")),
    array("value" => $FH->getArrayOrPostValue("secondary"))
);
$f->pop();
$f->pop();




$f->push(new Table());



$f->add(
    new TrFormElement(_T("Standby DHCP IP address"), new IPInputTpl("secondaryIp")),
    array("value" => $FH->getArrayOrPostValue("secondaryIp"))
);
$f->pop();

$f->push(new DivExpertMode());
$f->push(new Table());
$f->add(
    new TrFormElement(_T("Standby DHCP failover port"), new InputTpl("secondaryPort"),
    array("tooltip" => _T("TCP port where the server listen to failover messages", "network"))),
    array("value" => $FH->getArrayOrPostValue("secondaryPort"))
);
$f->add(
    new TrFormElement(_T("Max response delay"), new InputTpl("delay"),
    array("tooltip" => _T("How many seconds may pass without receiving a message from its failover peer before it assumes that connection has failed"))),
    array("value" => $FH->getArrayOrPostValue("delay"))
);
$f->add(
    new TrFormElement(_T("Max unacked updates"), new InputTpl("update")),
    array("value" => $FH->getArrayOrPostValue("update"))
);
$f->add(
    new TrFormElement(_T("Max load balance time"), new InputTpl("balance")),
    array("value" => $FH->getArrayOrPostValue("balance"))
);

$f->pop();

$dhcpPrimaryFailoverOptionsDiv = new Div(array("id" => "dhcpprimaryfailoveroptionsdiv"));
$dhcpPrimaryFailoverOptionsDiv->setVisibility($isPrimary || $isOneSideConfig);
$f->push($dhcpPrimaryFailoverOptionsDiv);
$f->push(new Table());

$f->add(
    new TrFormElement(_T("Maximum client lead time"), new InputTpl("mclt"),
    array("tooltip" => _T("Length of time for which a lease may be renewed by either failover peer without contacting the other"))),
    array("value" => $FH->getArrayOrPostValue("mclt"))
);
$f->add(
    new TrFormElement(_T("Split between the primary and secondary"), new InputTpl("split"),
    array("tooltip" => _T("Load balancing split between two peers: value is between 0 and 256, so a value of 256 means no load balancing, while 128 means a 50-50 load balance split"))),
    array("value" => $FH->getArrayOrPostValue("split"))
);
$f->pop();
$f->pop();

$f->addButton("bedit", _("Confirm"));
$f->addCancelButton("breset");

$f->pop();

$f->display();

?>
